## CaffeineViking-vkhr.zip

=== Makefile ===
name   = "vkhr"
config = "release"

all: shaders program
run: all
	bin/${name} ${args}
benchmark: all
	bin/${name} ${args} --benchmark yes

help: FORCE
	@echo "Usage: make [config=name] [target]"
	@echo ""
	@echo "CONFIGURATIONS:"
	@echo "  release"
	@echo "  debug"
	@echo ""
	@echo "TARGETS:"
	@echo "   all"
	@echo "   run"
	@echo "   benchmark"
	@echo "   help"
	@echo "   shaders"
	@echo "   program"
	@echo "   download"
	@echo "   download-modules"
	@echo "   pre-generate"
	@echo "   solution"
	@echo "   bundle-assets"
	@echo "   archive-build"
	@echo "   distribute"
	@echo "   docs"
	@echo "   tags"
	@echo "   clean"
	@echo "   distclean"
	@echo ""

program: FORCE
	premake5 gmake
	make -j8 -C build config=${config}

shaders: FORCE
	@-utils/glslc.py share/shaders/billboards
	@-make --no-print-directory -C share/shaders/billboards
	@-utils/glslc.py share/shaders/models
	@-make --no-print-directory -C share/shaders/models
	@-utils/glslc.py share/shaders/self-shadowing
	@-make --no-print-directory -C share/shaders/self-shadowing
	@-utils/glslc.py share/shaders/transparency
	@-make --no-print-directory -C share/shaders/transparency
	@-utils/glslc.py share/shaders/strands
	@-make --no-print-directory -C share/shaders/strands
	@-utils/glslc.py share/shaders/volumes
	@-make --no-print-directory -C share/shaders/volumes

download: download-modules
download-modules: FORCE
	git submodule update --init --recursive --depth 1

pre-generate: clean solution
	rm -rf build/.vs
	git add -f build
solution: FORCE
	premake5 vs2022

bundle-assets: FORCE
	rm -rf bin/share
	cp -r share bin/share

archive-build: FORCE
	mv bin ${name}
	zip -r ${name} ${name}
	mv ${name} bin

distribute: bundle-assets archive-build

docs: FORCE
	make -C docs
tags: FORCE
	ctags  -R     src/${name}    src/vkpp    include/${name}    include/vkpp
	cscope -Rb -s src/${name} -s src/vkpp -s include/${name} -s include/vkpp

clean: FORCE
	rm -rf build/obj
	rm -f  build/Makefile
	rm -f  build/${name}.make
	rm -rf docs/build
distclean: clean
	rm -f ${name}.zip
	rm -f cscope.out
	rm -f tags
	rm -f imgui.ini
	rm -rf bin/share
	rm -rf build/.vs
	find bin/ -type f ! \( -name "*.dll" -o -name "*.ico" \) -delete
FORCE:

.PHONY: all run benchmark help program shaders download download-modules pre-generate solution bundle-assets distribute docs tags clean distclean

=== docs/Makefile ===
name   := vkhr
viewer := mupdf

all: $(name).pdf
view: $(name).pdf
	$(viewer) $(name).pdf

$(name).pdf: $(name).tex $(name).bib
	mkdir -p build
	pdflatex -shell-escape -interaction=nonstopmode -output-directory build/ $(name)
	biber build/$(name)
	pdflatex -shell-escape -interaction=nonstopmode -output-directory build/ $(name)
	pdflatex -shell-escape -interaction=nonstopmode -output-directory build/ $(name)
	mv build/$(name).pdf .

clean:
	rm -rf build
distclean: clean
	rm -f $(name).pdf
.PHONY: all view clean distclean
FORCE:

=== share/shaders/billboards/Makefile ===
all: billboard.vert.spv billboard.frag.spv

billboard.vert.spv: billboard.vert billboard.glsl ../scene_graph/camera.glsl
	glslc -O -g -c billboard.vert

billboard.frag.spv: billboard.frag
	glslc -O -g -c billboard.frag

=== share/shaders/models/Makefile ===
all: model.vert.spv model.frag.spv

model.vert.spv: model.vert ../scene_graph/camera.glsl
	glslc -O -g -c model.vert

model.frag.spv: model.frag model.glsl ../scene_graph/lights.glsl ../scene_graph/shadow_maps.glsl ../scene_graph/params.glsl ../self-shadowing/../utils/rand.glsl ../self-shadowing/filter_shadows.glsl ../self-shadowing/linearize_depth.glsl ../shading/lambertian.glsl ../self-shadowing/tex2Dproj.glsl ../scene_graph/camera.glsl ../self-shadowing/../scene_graph/params.glsl
	glslc -O -g -c model.frag

=== share/shaders/self-shadowing/Makefile ===
all: depth_map.vert.spv

depth_map.vert.spv: depth_map.vert
	glslc -O -g -c depth_map.vert

=== share/shaders/strands/Makefile ===
all: strand.vert.spv strand.geom.spv strand.frag.spv

strand.vert.spv: strand.vert ../volumes/bounding_box.glsl ../scene_graph/camera.glsl strand.glsl
	glslc -O -g -c strand.vert

strand.geom.spv: strand.geom ../volumes/bounding_box.glsl ../scene_graph/camera.glsl strand.glsl
	glslc -O -g -c strand.geom

strand.frag.spv: strand.frag ../volumes/bounding_box.glsl strand.glsl ../scene_graph/params.glsl ../self-shadowing/../utils/math.glsl ../self-shadowing/../volumes/sample_volume.glsl ../self-shadowing/tex2Dproj.glsl ../anti-aliasing/gpaa.glsl ../self-shadowing/approximate_deep_shadows.glsl ../scene_graph/camera.glsl ../shading/kajiya-kay.glsl ../volumes/local_ambient_occlusion.glsl ../self-shadowing/../volumes/../utils/math.glsl ../self-shadowing/linearize_depth.glsl ../volumes/sample_volume.glsl ../level_of_detail/../scene_graph/params.glsl ../transparency/ppll.glsl ../level_of_detail/scheme.glsl ../scene_graph/lights.glsl ../scene_graph/shadow_maps.glsl
	glslc -O -g -c strand.frag

=== share/shaders/transparency/Makefile ===
all: resolve.comp.spv

resolve.comp.spv: resolve.comp ppll.glsl
	glslc -O -g -c resolve.comp

=== share/shaders/volumes/Makefile ===
all: volume.vert.spv volume.frag.spv voxelize.comp.spv

volume.vert.spv: volume.vert ../strands/../volumes/bounding_box.glsl ../strands/strand.glsl ../scene_graph/camera.glsl volume.glsl
	glslc -O -g -c volume.vert

volume.frag.spv: volume.frag ../strands/strand.glsl volume.glsl ../scene_graph/params.glsl ../self-shadowing/../utils/math.glsl ../self-shadowing/../volumes/../utils/math.glsl ../strands/../volumes/bounding_box.glsl ../self-shadowing/approximate_deep_shadows.glsl ../shading/kajiya-kay.glsl ../self-shadowing/../volumes/sample_volume.glsl ../self-shadowing/tex2Dproj.glsl ../self-shadowing/linearize_depth.glsl ../level_of_detail/../scene_graph/params.glsl ../transparency/ppll.glsl ../level_of_detail/scheme.glsl raymarch.glsl sample_volume.glsl ../scene_graph/lights.glsl volume_rendering.glsl ../scene_graph/camera.glsl local_ambient_occlusion.glsl
	glslc -O -g -c volume.frag

voxelize.comp.spv: voxelize.comp ../strands/../volumes/bounding_box.glsl bounding_box.glsl sample_volume.glsl ../strands/strand.glsl ../utils/math.glsl
	glslc -O -g -c voxelize.comp

=== utils/PKGBUILD ===
# Maintainer: Erik S. V. Jansson <caffeineviking@gmail.com>

pkgname=vkhr-git
pkgver=VERSION
pkgrel=1
pkgdesc="Real-Time Hybrid Hair Renderer Written in Vulkan(TM)."
arch=('i686' 'x86_64')
url="https://github.com/CaffeineViking/vkhr"
license=('MIT')
provides=('vkhr')
depends=('embree' 'glfw' 'vulkan-icd-loader' 'vulkan-headers')
makedepends=('git' 'git-lfs' 'premake-git')
source=('git+https://github.com/CaffeineViking/vkhr')
md5sums=('SKIP')

pkgver() {
	cd vkhr
	printf "r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

build() {
	cd vkhr
	make download-modules
	export DEFINES='-DVKHR_ASSETS_PATH=\"/usr/share/vkhr/\"'
	make config=release
}

package() {
	cd vkhr

	install -Dm755 bin/vkhr "$pkgdir"/usr/bin/vkhr
	install -Dm755 docs/vkhr.1 "$pkgdir"/usr/share/man/man1/vkhr.1
	install -Dm644 license.md "$pkgdir"/usr/share/licenses/vkhr/LICENSE

	install -Dm644 share/images/vulkan_icon.png "$pkgdir"/usr/share/vkhr/images/vulkan_icon.png

	install -Dm644 share/models/bear/bear.obj "$pkgdir"/usr/share/vkhr/models/bear/bear.obj
	install -Dm644 share/models/bear/bear.bmp "$pkgdir"/usr/share/vkhr/models/bear/bear.bmp
	install -Dm644 share/models/ponytail/ponytail.obj "$pkgdir"/usr/share/vkhr/models/ponytail/ponytail.obj
	install -Dm644 share/models/ponytail/ponytail.bmp "$pkgdir"/usr/share/vkhr/models/ponytail/ponytail.bmp

	install -Dm644 share/scenes/bear.vkhr "$pkgdir"/usr/share/vkhr/scenes/bear.vkhr
	install -Dm644 share/scenes/ponytail.vkhr "$pkgdir"/usr/share/vkhr/scenes/ponytail.vkhr

	install -Dm644 share/shaders/anti-aliasing/gpaa.glsl "$pkgdir"/usr/share/vkhr/shaders/anti-aliasing/gpaa.glsl

	install -Dm644 share/shaders/billboards/billboard.frag "$pkgdir"/usr/share/vkhr/shaders/billboards/billboard.frag
	install -Dm644 share/shaders/billboards/billboard.frag.spv "$pkgdir"/usr/share/vkhr/shaders/billboards/billboard.frag.spv
	install -Dm644 share/shaders/billboards/billboard.glsl "$pkgdir"/usr/share/vkhr/shaders/billboards/billboard.glsl
	install -Dm644 share/shaders/billboards/billboard.vert "$pkgdir"/usr/share/vkhr/shaders/billboards/billboard.vert
	install -Dm644 share/shaders/billboards/billboard.vert.spv "$pkgdir"/usr/share/vkhr/shaders/billboards/billboard.vert.spv

	install -Dm644 share/shaders/level_of_detail/scheme.glsl "$pkgdir"/usr/share/vkhr/shaders/level_of_detail/scheme.glsl

	install -Dm644 share/shaders/models/model.frag "$pkgdir"/usr/share/vkhr/shaders/models/model.frag
	install -Dm644 share/shaders/models/model.frag.spv "$pkgdir"/usr/share/vkhr/shaders/models/model.frag.spv
	install -Dm644 share/shaders/models/model.glsl "$pkgdir"/usr/share/vkhr/shaders/models/model.glsl
	install -Dm644 share/shaders/models/model.vert "$pkgdir"/usr/share/vkhr/shaders/models/model.vert
	install -Dm644 share/shaders/models/model.vert.spv "$pkgdir"/usr/share/vkhr/shaders/models/model.vert.spv

	install -Dm644 share/shaders/scene_graph/camera.glsl "$pkgdir"/usr/share/vkhr/shaders/scene_graph/camera.glsl
	install -Dm644 share/shaders/scene_graph/lights.glsl "$pkgdir"/usr/share/vkhr/shaders/scene_graph/lights.glsl
	install -Dm644 share/shaders/scene_graph/params.glsl "$pkgdir"/usr/share/vkhr/shaders/scene_graph/params.glsl
	install -Dm644 share/shaders/scene_graph/shadow_maps.glsl "$pkgdir"/usr/share/vkhr/shaders/scene_graph/shadow_maps.glsl

	install -Dm644 share/shaders/self-shadowing/approximate_deep_shadows.glsl "$pkgdir"/usr/share/vkhr/shaders/self-shadowing/approximate_deep_shadows.glsl
	install -Dm644 share/shaders/self-shadowing/depth_map.vert "$pkgdir"/usr/share/vkhr/shaders/self-shadowing/depth_map.vert
	install -Dm644 share/shaders/self-shadowing/depth_map.vert.spv "$pkgdir"/usr/share/vkhr/shaders/self-shadowing/depth_map.vert.spv
	install -Dm644 share/shaders/self-shadowing/filter_shadows.glsl "$pkgdir"/usr/share/vkhr/shaders/self-shadowing/filter_shadows.glsl
	install -Dm644 share/shaders/self-shadowing/linearize_depth.glsl "$pkgdir"/usr/share/vkhr/shaders/self-shadowing/linearize_depth.glsl
	install -Dm644 share/shaders/self-shadowing/tex2Dproj.glsl "$pkgdir"/usr/share/vkhr/shaders/self-shadowing/tex2Dproj.glsl

	install -Dm644 share/shaders/shading/kajiya-kay.glsl "$pkgdir"/usr/share/vkhr/shaders/shading/kajiya-kay.glsl
	install -Dm644 share/shaders/shading/lambertian.glsl "$pkgdir"/usr/share/vkhr/shaders/shading/lambertian.glsl

	install -Dm644 share/shaders/strands/strand.frag "$pkgdir"/usr/share/vkhr/shaders/strands/strand.frag
	install -Dm644 share/shaders/strands/strand.frag.spv "$pkgdir"/usr/share/vkhr/shaders/strands/strand.frag.spv
	install -Dm644 share/shaders/strands/strand.glsl "$pkgdir"/usr/share/vkhr/shaders/strands/strand.glsl
	install -Dm644 share/shaders/strands/strand.vert "$pkgdir"/usr/share/vkhr/shaders/strands/strand.vert
	install -Dm644 share/shaders/strands/strand.vert.spv "$pkgdir"/usr/share/vkhr/shaders/strands/strand.vert.spv

	install -Dm644 share/shaders/transparency/ppll.glsl "$pkgdir"/usr/share/vkhr/shaders/transparency/ppll.glsl
	install -Dm644 share/shaders/transparency/resolve.comp "$pkgdir"/usr/share/vkhr/shaders/transparency/resolve.comp
	install -Dm644 share/shaders/transparency/resolve.comp.spv "$pkgdir"/usr/share/vkhr/shaders/transparency/resolve.comp.spv

	install -Dm644 share/shaders/utils/math.glsl "$pkgdir"/usr/share/vkhr/shaders/utils/math.glsl
	install -Dm644 share/shaders/utils/rand.glsl "$pkgdir"/usr/share/vkhr/shaders/utils/rand.glsl

	install -Dm644 share/shaders/volumes/bounding_box.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/bounding_box.glsl
	install -Dm644 share/shaders/volumes/filtered_raymarch.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/filtered_raymarch.glsl
	install -Dm644 share/shaders/volumes/local_ambient_occlusion.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/local_ambient_occlusion.glsl
	install -Dm644 share/shaders/volumes/raymarch.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/raymarch.glsl
	install -Dm644 share/shaders/volumes/sample_volume.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/sample_volume.glsl
	install -Dm644 share/shaders/volumes/volume.frag "$pkgdir"/usr/share/vkhr/shaders/volumes/volume.frag
	install -Dm644 share/shaders/volumes/volume.frag.spv "$pkgdir"/usr/share/vkhr/shaders/volumes/volume.frag.spv
	install -Dm644 share/shaders/volumes/volume.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/volume.glsl
	install -Dm644 share/shaders/volumes/volume_rendering.glsl "$pkgdir"/usr/share/vkhr/shaders/volumes/volume_rendering.glsl
	install -Dm644 share/shaders/volumes/volume.vert "$pkgdir"/usr/share/vkhr/shaders/volumes/volume.vert
	install -Dm644 share/shaders/volumes/volume.vert.spv "$pkgdir"/usr/share/vkhr/shaders/volumes/volume.vert.spv
	install -Dm644 share/shaders/volumes/voxelize.comp "$pkgdir"/usr/share/vkhr/shaders/volumes/voxelize.comp
	install -Dm644 share/shaders/volumes/voxelize.comp.spv "$pkgdir"/usr/share/vkhr/shaders/volumes/voxelize.comp.spv

	install -Dm644 share/styles/bear.hair "$pkgdir"/usr/share/vkhr/styles/bear.hair
	install -Dm644 share/styles/ponytail.hair "$pkgdir"/usr/share/vkhr/styles/ponytail.hair
}
